function do_confirm(imageId) {
    document.getElementById('aep_prompt').innerHTML = ipAjaxVar.swal_confirm_operation;
    document.getElementById('aep_ww').classList.add('is-active');

    document.querySelector('.aep_ok').dataset.imageId = imageId;
}

function do_click(m) {
    // Hide confirm modal
    document.getElementById('aep_ww').classList.remove('is-active');

    if (!m) {
        // false
    } else {
        // true
        var id = document.querySelector('.aep_ok').dataset.imageId;

        xhrRequest('imagepress_delete_post', '&id=' + id, function (caller) {
            document.getElementById('listItem_' + id).remove();
        });

        return false;
    }
}

function toggle(selector) {
    if (selector.style.display == 'none') {
        selector.style.display = 'block'
    } else {
        selector.style.display = 'none'
    }
}

if (document.querySelector('.aep_ok')) {
    document.querySelector('.aep_ok').addEventListener('click', function () {
        do_click(true);
    });
    document.querySelector('.aep_cancel').addEventListener('click', function () {
        do_click(false);
    });
}



function xhrRequest(action, args, on_success) {
    var request = new XMLHttpRequest();

    request.open('POST', ipAjaxVar.ajaxurl, true);
    request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
    request.onload = function (response) {
        if (this.status >= 200 && this.status < 400) {
            // Response success
            on_success(this);
        } else {
            // Response error
        }
    };
    request.onerror = function() {
        // Connection error
    };
    request.send('action=' + action + '&nonce=' + ipAjaxVar.nonce + args);
}



/**
 * ImagePress Javascript functions
 */
document.addEventListener('DOMContentLoaded', function () {
    /*
    if (document.querySelector('.cinnamon-cover')) {
        document.querySelector('.cinnamon-cover').style.backgroundImage = 'url(' + document.querySelector('.cinnamon-cover').dataset.background + ')';
    }
    /**/

    if (document.querySelector('.cinnamon-cover-preview')) {
        document.querySelector('.cinnamon-cover-preview').style.background = 'url(' + document.querySelector('.cinnamon-cover-preview').dataset.background + ') no-repeat center center / cover';
    }

    if (document.querySelector('.imagepress-custom-validity')) {
        let on_invalid = document.querySelector('.imagepress-custom-validity').dataset.customValidity;

        document.getElementById('imagepress_agree').setCustomValidity(on_invalid);

        document.getElementById('imagepress_agree').addEventListener('change', () => {
            document.getElementById('imagepress_agree').setCustomValidity(document.getElementById('imagepress_agree').validity.valueMissing ? on_invalid : '');
        });
    }

    /**
     * Record Like action for custom post type
     */
    if (document.querySelector('.imagepress-like')) {
        document.querySelector('.imagepress-like').addEventListener('click', function (e) {
            e.preventDefault();
            e.stopImmediatePropagation();

            var likeLabel,
                like = this,
                pid = like.dataset.post_id;

            like.innerHTML = '<i class="icofont-heart"></i> <i class="icofont-hour-glass"></i></i>';

            xhrRequest('imagepress-like', '&imagepress_like=&post_id=' + pid, function (caller) {
                if (caller.response.indexOf('already') !== -1) {
                    if (caller.response.replace('already', '') === '0') {
                        likeLabel = ipAjaxVar.likelabel;
                    }
                    like.classList.remove('liked');
                    like.innerHTML = '<i class="icofont-heart"></i> ' + likeLabel;
                } else {
                    likeLabel = ipAjaxVar.unlikelabel;
                    like.classList.add('liked');
                    like.innerHTML = '<i class="icofont-heart icofont-heart--not-liked"></i> ' + likeLabel;
                }
            });

            return false;
        });
    }



    /*
     * Drag & Drop Uploader
     */
    if (document.getElementById('dropContainer')) {
        document.getElementById('dropContainer').ondragover = document.getElementById('dropContainer').ondragenter = function(evt) {
            evt.preventDefault();
        };

        document.getElementById('dropContainer').ondrop = function(evt) {
            document.getElementById('imagepress_image_file').files = evt.dataTransfer.files;
            // Display selected image
            // document.getElementById("dropContainer").innerHTML = document.getElementById('imagepress_image_file').files[0].name;

            evt.preventDefault();
        };
    }



    if (document.getElementById('imagepress_upload_image_form')) {
        document.getElementById('imagepress_upload_image_form').addEventListener('submit', function () {
            document.getElementById('imagepress_submit').disabled = true;
            document.getElementById('imagepress_submit').style.setProperty('opacity', '0.5');
            document.getElementById('ipload').innerHTML = '<i class="icofont-upload-alt"></i> Uploading...';
        });
    }
    /* end upload */

    /* imagepress_editor() related actions */
    if (document.querySelector('.ip-editor')) {
        var container = document.querySelector('.ip-editor');

        document.getElementById('ip-editor-open').addEventListener('click', function (event) {
            event.preventDefault();

            if (!container.classList.contains('active')) {
                container.classList.add('active');
                container.style.height = 'auto';

                var height = container.clientHeight + 'px';

                container.style.height = '0px';

                setTimeout(function () {
                    container.style.height = height;
                }, 0);
            } else {
                container.style.height = '0px';

                container.addEventListener('transitionend', function () {
                    container.classList.remove('active');
                }, {
                    once: true
                });
            }
        });

        if (document.querySelector('.ip-delete-post')) {
            var elements = document.querySelectorAll('.ip-delete-post');

            for (var i = 0; i < elements.length; i++) {
                elements[i].addEventListener('click', function (e) {
                    e.preventDefault();

                    var id = this.dataset.imageId;

                    xhrRequest('imagepress_delete_post', '&id=' + id, function (caller) {
                        document.querySelector('.ip-additional-' + id).remove();
                    });
                });
            }
        }
    }



    if (document.querySelector("ul.imagepress--tabs")) {
        var tabLinks = document.querySelectorAll("ul.imagepress--tabs li a");

        [].forEach.call(tabLinks, function (el) {
            el.addEventListener("click", function (e) {
                e.preventDefault();

                var target = this.getAttribute("href").replace("#", "");
                var sections = document.querySelectorAll("div.imagepress--tab");

                for (var j = 0; j < sections.length; j++) {
                    sections[j].style.display = "none";
                }

                document.getElementById(target).style.display = "block";

                for (var k = 0; k < tabLinks.length; k++) {
                    tabLinks[k].removeAttribute("class");
                }

                this.setAttribute("class", "is-active");

                return false;
            });
        });
    }



    if (document.querySelector('.clickable-span')) {
        const clickableLinks = document.querySelectorAll('.clickable-span');

        [].forEach.call(clickableLinks, el => {
            el.addEventListener('click', e => {
                e.preventDefault();

                do_confirm(el.dataset.imageId);
            });
        });
    }



    document.querySelector('body').addEventListener('click', function(event) {
        if (typeof event.target.className === 'string' && event.target.className.indexOf('changeCollection') !== -1) {
            document.querySelector('.cde' + event.target.dataset.collectionId).classList.toggle('active');

            event.preventDefault();
        }

        if (typeof event.target.className === 'string' && event.target.className.indexOf('closeCollectionEdit') !== -1) {
            document.querySelector('.cde' + event.target.dataset.collectionId).classList.toggle('active');

            event.preventDefault();
        }

        if (event.target.matches('.imagepress-follow a')) {
            if (typeof ipAjaxVar.logged_in !== 'undefined' && ipAjaxVar.logged_in !== 'true') {
                alert(ipAjaxVar.login_required);
                return;
            }

            //const $this = e.currentTarget;
            const action = event.target.classList.contains('follow') ? 'follow' : 'unfollow';
            const imagepressAjax = document.querySelector('img.imagepress-ajax');

            imagepressAjax.style.display = 'inline-block';

            xhrRequest(action, `&user_id=${event.target.dataset.userId}&follow_id=${event.target.dataset.followId}`, () => {
                document.querySelectorAll('.imagepress-follow a').forEach((link) => toggle(link));

                imagepressAjax.style.display = 'none';
            });
        }

        if (event.target.classList.contains('deleteCollection')) {
            event.preventDefault();

            const ipc = event.target.dataset.collectionId;

            //document.querySelectorAll('.deleteCollection').forEach((element) => {
            //    element.style.display = 'none';
            //});

            xhrRequest(
                'deleteCollection',
                `&collection_id=${ipc}`,
                () => {
                    document.querySelectorAll(`.ipc${ipc}`).forEach((element) => {
                        element.style.display = 'none';
                    });
                    document.querySelectorAll('.ip-loadingCollections').forEach((element) => {
                        element.style.display = 'none';
                    });
                }
            );
        }

        if (event.target.classList.contains('saveCollection')) {
            event.preventDefault();

            const ipc = event.target.dataset.collectionId;
            const collectionTitle = document.querySelector(`.ct${ipc}`).value;

            xhrRequest(
                'editCollectionTitle',
                `&collection_id=${ipc}&collection_title=${collectionTitle}`,
                () => {
                    document.querySelectorAll('.collection_details_edit').forEach((element) => {
                        element.classList.remove('active');
                    });
                    document.querySelector('.ip-loadingCollections').style.display = 'inline-block';

                    xhrRequest('ip_collections_display', '', function (caller) {
                        document.querySelector('.collections-display').innerHTML = caller.response;
                        document.querySelector('.ip-loadingCollections').style.display = 'none';
                    });
                }
            );
        }

        if (event.target.classList.contains('collection-status')) {
            event.preventDefault();

            const ipc = event.target.dataset.collectionId;
            const option = event.target.options[event.target.selectedIndex];

            xhrRequest(
                'editCollectionStatus',
                `&collection_id=${ipc}&collection_status=${option.value}`,
                () => {
                    document.querySelectorAll(`.cde${ipc}`).forEach((element) => {
                        element.style.display = 'none';
                    });
                }
            );
        }

        if (event.target.classList.contains('toggleModal')) {
                document.querySelector('.ip-modal').classList.toggle('active');

                event.preventDefault();
        }

    });

    if (document.querySelector('.toggleFrontEndModal')) {
        document.querySelector('.toggleFrontEndModal').addEventListener('click', function(e) {
            document.querySelector('.frontEndModal').classList.toggle('active');

            e.preventDefault();
        });
        document.querySelector('.toggleFrontEndModal.close').addEventListener('click', function(e) {
            document.querySelector('.frontEndModal').classList.toggle('active');

            e.preventDefault();
        });
    }

    if (document.querySelector('.addCollection')) {
        document.querySelector('.addCollection').addEventListener('click', (e) => {
            e.preventDefault();

            document.querySelector('.addCollection').value = 'Creating...';
            document.querySelectorAll('.collection-progress').forEach((element) => element.style.display = 'block');

            xhrRequest(
                'addCollection',
                `&collection_author_id=${document.querySelector('#collection_author_id').value}&collection_title=${document.querySelector('#collection_title').value}&collection_status=${document.querySelector('#collection_status').value}`,
                () => {
                    document.querySelector('.addCollection').value = 'Create another collection';
                    document.querySelectorAll('.collection-progress').forEach((element) => element.style.display = 'none');
                    document.querySelectorAll('.showme').forEach((element) => element.style.display = 'block');
                }
            );
        });
    }

    if (document.querySelector('.ip-modal .close')) {
        document.querySelector('.ip-modal .close').addEventListener('click', function (e) {
            xhrRequest('ip_collections_display', '', function (caller) {
                document.querySelector('.collections-display').innerHTML = caller.response;
            });

            e.preventDefault();
        });
    }

    if (document.querySelector('.imagepress-collections')) {
        document.querySelector('.imagepress-collections').addEventListener('click', function (e) {
            document.querySelector('.ip-loadingCollections').style.display = 'inline-block';

            xhrRequest('ip_collections_display', '', function (caller) {
                document.querySelector('.collections-display').innerHTML = caller.response;
                document.querySelector('.ip-loadingCollections').style.display = 'none';
            });

            e.preventDefault();
        });
    }
    /* end collections */

    // Sortable images inside profile editor
    if (document.querySelector('.editor-image-manager')) {
        var list = document.querySelector('.editor-image-manager');
        var sortable = Sortable.create(list, {
            sort: true,
            onUpdate: function () {
                var order = sortable.toArray();

                xhrRequest('imagepress_list_update_order', '&order=' + order, function (caller) {
                    // Sort success
                });
            },
        });
    }

    if (document.querySelector('.editableImage')) {
        var editableImageTriggers = document.querySelectorAll('.editableImage');

        [].forEach.call(editableImageTriggers, function (el) {
            el.addEventListener('keydown', function (e) {
                if (e.keyCode === 10 || e.keyCode === 13) {
                    e.preventDefault();

                    var id = this.dataset.imageId;
                    var title = this.value;

                    document.querySelector('.editableImageStatus_' + id).innerHTML = '<i class="icofont-hour-glass"></i>';
                    document.querySelector('.editableImageStatus_' + id).style.display = 'inline-block';

                    xhrRequest('imagepress_update_post_title', '&title=' + title + '&id=' + id, function (caller) {
                        document.querySelector('.editableImageStatus_' + id).innerHTML = '<i class="icofont-check"></i>';
                        document.querySelector('.editableImageStatus_' + id).style.display = 'inline-block';
                    });
                }
            });
        });
    }



    /**
     * Cinnamon Cards
     */

    // Cinnamon cards pagination
    if (document.getElementById("cinnamon-cards--paginated")) {
        const itemsPerPage = document.getElementById("cinnamon-cards--paginated").dataset.app;
        const cinnamonList = document.getElementById("cinnamon-cards--paginated");
        const liItems = Array.from(cinnamonList.getElementsByTagName("li"));
        const totalPages = Math.ceil(liItems.length / itemsPerPage);

        const showPage = (page) => {
            const start = (page - 1) * itemsPerPage;
            const end = start + itemsPerPage;

            liItems.forEach((li, index) => {
                li.style.display = index >= start && index < end ? "flex" : "none";
            });
        };

        const createPaginationButtons = () => {
            const paginationButtons = document.getElementById("pagination-buttons");

            for (let i = 1; i <= totalPages; i++) {
                const button = document.createElement("button");
                button.textContent = i;
                button.addEventListener("click", () => {
                    showPage(i);
                });
                paginationButtons.appendChild(button);
            }
        };

        showPage(1);
        createPaginationButtons();
    }

    // Cinnamon cards equal image height
    if (document.querySelector(".imagepress--equal-height img")) {
        // Retrieve all images with a specific class
        const images = document.querySelectorAll(".imagepress--equal-height img");

        // Find the minimum height among all the images
        let minHeight = Number.MAX_SAFE_INTEGER;
        images.forEach(image => {
            const height = image.offsetHeight;
            minHeight = Math.min(minHeight, height);
        });

        // Set the same height for all the images
        images.forEach((image) => {
            image.style.height = `${minHeight}px`;
            image.style.width = `auto`;
        });
    }
});






























function getUrlParameter(sParam) {
    var sPageURL = decodeURIComponent(window.location.search.substring(1)),
        sURLVariables = sPageURL.split('&'),
        sParameterName,
        i;

    for (i = 0; i < sURLVariables.length; i++) {
        sParameterName = sURLVariables[i].split('=');

        if (sParameterName[0] === sParam) {
            return typeof sParameterName[1] === 'undefined' ? true : sParameterName[1];
        }
    }
}

document.addEventListener('DOMContentLoaded', function() {
    if (document.getElementById('ip-sorter-primary')) {
        var requestUri = window.location.search,
            sorterDropdown = document.getElementById('sorter'),
            rangerDropdown = document.getElementById('ranger'),
            taxxxerDropdown = document.getElementById('taxxxer'),
            queryLocation;

        // Check URI parameters, select default values, and redirect based on user selection
        if (getUrlParameter('sort') !== null) {
            sorterDropdown.value = requestUri;
        } else {
            sorterDropdown.selectedIndex = 0;
        }

        if (getUrlParameter('range') !== null) {
            rangerDropdown.value = requestUri;
        } else {
            rangerDropdown.selectedIndex = 0;
        }

        if (getUrlParameter('t') !== null) {
            taxxxerDropdown.value = requestUri;
        } else {
            taxxxerDropdown.selectedIndex = 0;
        }

        // Check if dropdown has changed on page load
        sorterDropdown.onchange = function () {
            document.getElementById('ip-sorter-loader').innerHTML = '<i class="icofont-hour-glass"></i>';
            window.location.href = sorterDropdown.value;
        };
        rangerDropdown.onchange = function () {
            document.getElementById('ip-sorter-loader').innerHTML = '<i class="icofont-hour-glass"></i>';
            window.location.href = rangerDropdown.value;
        };
        taxxxerDropdown.onchange = function () {
            document.getElementById('ip-sorter-loader').innerHTML = '<i class="icofont-hour-glass"></i>';
            window.location.href = taxxxerDropdown.value;
        };
    }
}, !1);
